// ==========================================================================
// GFast自动生成logic操作代码。
// 生成日期：2023-01-31 09:33:48
// 生成路径: internal/app/cms/logic/cms_category.go
// 生成人：yxf
// desc:文章分类
// company:云南奇讯科技有限公司
// ==========================================================================

package logic

import (
	"context"
	"github.com/gogf/gf/v2/frame/g"
	"github.com/gogf/gf/v2/util/gconv"
	"github.com/tiger1103/gfast/v3/api/v1/cms"
	"github.com/tiger1103/gfast/v3/internal/app/cms/dao"
	"github.com/tiger1103/gfast/v3/internal/app/cms/model"
	"github.com/tiger1103/gfast/v3/internal/app/cms/model/do"
	"github.com/tiger1103/gfast/v3/internal/app/cms/service"
	"github.com/tiger1103/gfast/v3/library/libUtils"
	"github.com/tiger1103/gfast/v3/library/liberr"
)

func init() {
	service.RegisterCmsCategory(New())
}

func New() *sCmsCategory {
	return &sCmsCategory{}
}

type sCmsCategory struct{}

func (s *sCmsCategory) List(ctx context.Context, req *cms.CmsCategorySearchReq) (listRes *cms.CmsCategorySearchRes, err error) {
	listRes = new(cms.CmsCategorySearchRes)
	err = g.Try(ctx, func(ctx context.Context) {
		m := dao.CmsCategory.Ctx(ctx).WithAll()
		if req.Name != "" {
			m = m.Where(dao.CmsCategory.Columns().Name+" like ?", "%"+req.Name+"%")
		}
		if req.Status != "" {
			m = m.Where(dao.CmsCategory.Columns().Status+"=?", req.Status)
		}
		if req.ParentId != "" {
			m = m.Where(dao.CmsCategory.Columns().ParentId+"=?", req.ParentId)
		}
		if req.Type != "" {
			m = m.Where(dao.CmsCategory.Columns().Type+"=?", req.Type)
		}
		order := "sort asc, id asc"
		if req.OrderBy != "" {
			order = req.OrderBy
		}
		var res []*model.CmsCategoryInfoRes
		err = m.Fields(cms.CmsCategorySearchRes{}).Order(order).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取数据失败")
		listRes.List = make([]*model.CmsCategoryListRes, len(res))
		for k, v := range res {
			listRes.List[k] = &model.CmsCategoryListRes{
				Id:             v.Id,
				Name:           v.Name,
				ParentId:       v.ParentId,
				Type:           v.Type,
				ModuleId:       v.ModuleId,
				LinkedModuleId: v.LinkedModuleId,
				Sort:           v.Sort,
				Thumb:          v.Thumb,
				Status:         v.Status,
				Alias:          v.Alias,
				JumpUrl:        v.JumpUrl,
			}
		}
	})
	return
}

func (s *sCmsCategory) GetById(ctx context.Context, id uint) (res *model.CmsCategoryInfoRes, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		err = dao.CmsCategory.Ctx(ctx).WithAll().Where(dao.CmsCategory.Columns().Id, id).Scan(&res)
		liberr.ErrIsNil(ctx, err, "获取信息失败")
	})
	return
}

func (s *sCmsCategory) Add(ctx context.Context, req *cms.CmsCategoryAddReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		for _, obj := range req.Banner {
			obj.Url, err = libUtils.GetFilesPath(ctx, obj.Url)
			liberr.ErrIsNil(ctx, err)
		}
		_, err = dao.CmsCategory.Ctx(ctx).Insert(do.CmsCategory{
			Name:            req.Name,
			Type:            req.Type,
			SeoTitle:        req.SeoTitle,
			Keywords:        req.Keywords,
			Description:     req.Description,
			Content:         req.Content,
			ParentId:        req.ParentId,
			ModuleId:        req.ModuleId,
			Sort:            req.Sort,
			Template:        req.Template,
			ContentTemplate: req.ContentTemplate,
			IsInherit:       req.IsInherit,
			Thumb:           req.Thumb,
			Banner:          req.Banner,
			Status:          req.Status,
			PageTemplate:    req.PageTemplate,
			ChannelTemplate: req.ChannelTemplate,
			JumpUrl:         req.JumpUrl,
			Alias:           req.Alias,
		})
		liberr.ErrIsNil(ctx, err, "添加失败")
	})
	return
}

func (s *sCmsCategory) Edit(ctx context.Context, req *cms.CmsCategoryEditReq) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		for _, obj := range req.Banner {
			obj.Url, err = libUtils.GetFilesPath(ctx, obj.Url)
			liberr.ErrIsNil(ctx, err)
		}
		_, err = dao.CmsCategory.Ctx(ctx).WherePri(req.Id).Update(do.CmsCategory{
			Name:            req.Name,
			Type:            req.Type,
			SeoTitle:        req.SeoTitle,
			Keywords:        req.Keywords,
			Description:     req.Description,
			Content:         req.Content,
			ParentId:        req.ParentId,
			ModuleId:        req.ModuleId,
			Sort:            req.Sort,
			Template:        req.Template,
			ContentTemplate: req.ContentTemplate,
			IsInherit:       req.IsInherit,
			Thumb:           req.Thumb,
			Banner:          req.Banner,
			Status:          req.Status,
			PageTemplate:    req.PageTemplate,
			ChannelTemplate: req.ChannelTemplate,
			JumpUrl:         req.JumpUrl,
			Alias:           req.Alias,
		})
		liberr.ErrIsNil(ctx, err, "修改失败")
	})
	return
}

func (s *sCmsCategory) Delete(ctx context.Context, ids []uint) (err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		var childrenIds []uint
		childrenIds, err = s.GetChildrenIds(ctx, ids)
		liberr.ErrIsNil(ctx, err)
		ids = append(ids, childrenIds...)
		_, err = dao.CmsCategory.Ctx(ctx).Delete(dao.CmsCategory.Columns().Id+" in (?)", ids)
		liberr.ErrIsNil(ctx, err, "删除失败")
	})
	return
}

// GetChildrenIds 通过ID获取子级ID
func (s *sCmsCategory) GetChildrenIds(ctx context.Context, ids []uint) (returnIds []uint, err error) {
	err = g.Try(ctx, func(ctx context.Context) {
		//获取所有
		var all *cms.CmsCategorySearchRes
		all, err = s.List(ctx, &cms.CmsCategorySearchReq{})
		liberr.ErrIsNil(ctx, err)
		list := make(g.List, len(all.List))
		for k, info := range all.List {
			list[k] = gconv.Map(info)
		}
		returnIds = ids
		for _, id := range ids {
			children := libUtils.FindSonByParentId(list, id, "parentId", "id")
			for _, cid := range children {
				returnIds = append(returnIds, cid["id"].(uint))
			}
		}
	})
	return
}
